Attribute VB_Name = "Module2"
Public eps As Integer, thk As Single
Public dirWt() As Single


Public Function DirectiveGrad(F() As Byte, xSize As Integer, ySize As Integer, xi As Integer, yi As Integer, dirGrads() As Single) As Integer
Dim dirNo As Integer, dirGap As Single
Dim a As Integer, b As Integer, i As Integer
Dim xx As Single, yy As Single, stp As Integer, wdth As Integer
Dim xxt As Single, yyt As Single
Dim pt As Single, wtsum As Single, wt As Single
Dim rFact As Single, rIndx As Integer, maxthk As Integer '**
Dim xp As Single, yp As Single

' dirNo is the number of directional lines along which the search is done
dirNo = 8  ' Can't be changed

xp = CSng(xi)
yp = CSng(yi)
pt = CSng(F(xi, yi))

i = -1
For a = -1 To 1
    For b = -1 To 1
        i = i + 1
        If a = 0 And b = 0 Then
            i = i - 1
            GoTo ths
        End If
        dirGrads(i) = 0
        wtsum = 0
        If a * b = 0 Then
            rFact = 1
            rIndx = 0 '**
        Else
            rFact = Root2
            rIndx = 1 '**
        End If
        For stp = 1 To eps '***
            'xx = xp + setSign(a, stp)
            'yy = yp + setSign(b, stp)
            xx = xp + a * stp / rFact '***
            yy = yp + b * stp / rFact '***
            maxthk = CInt(thk * stp)
            For wdth = -maxthk To maxthk
                xxt = xx + b * wdth / rFact '***
                yyt = yy - a * wdth / rFact '***
                'xxt = xx + setSign(a, wdth)
                'yyt = yy - setSign(b, wdth)
                If (xxt >= 0) And (yyt >= 0) And (xxt < xSize) And (yyt < ySize) Then
                    ' dirGrads(i) = dirGrads(i) + CSng(F(xx, yy)) * (CSng(F(xx, yy)) - pt) / r
                    ' wt = 1 / (r * CSng(Abs(wdth) + 1))
                    wt = dirWt(stp, Abs(wdth), 0) '***
                    dirGrads(i) = dirGrads(i) + CSng(F(Round(xxt), Round(yyt))) * wt '***
                    wtsum = wtsum + wt
                End If
            Next wdth
        Next stp
        If Not (dirGrads(i) = 0) Then
            dirGrads(i) = dirGrads(i) / wtsum
        End If
ths:
    Next b
Next a

DirectiveGrad = 1
End Function


Public Function GetMeans(F() As Byte, xSize As Integer, ySize As Integer, xCg As Integer, yCg As Integer, prDir As Single) As Integer
' Returns the CG and Principal direction (angle mage with +ve X-axis in radians) of the complement of F

Dim xi As Integer, yi As Integer, x1 As Integer, y1 As Integer
Dim m As Long, MX As Long, MXX As Long, MY As Long, MYY As Long, MXY As Long
Dim mi As Long, Mpr1 As Single, Mpr2 As Single, mSlop As Single, mDist As Single, mResDist As Single, DistMajor As Single, DistMinor As Single
'Dim Mmajor1 As Single, Mmajor2 As Single, Mminor1 As Single, Mminor2 As Single

m = 0
MX = 0
MXX = 0
MY = 0
MYY = 0
MXY = 0

For xi = 0 To xSize - 1
    For yi = 0 To ySize - 1
        mi = CLng(255 - F(xi, yi))
        m = m + mi
        MX = MX + yi * mi
        MY = MY + xi * mi
    Next yi
Next xi

xCg = CInt(CSng(MY) / CSng(m))
yCg = CInt(CSng(MX) / CSng(m))

For xi = 0 To xSize - 1
    For yi = 0 To ySize - 1
        x1 = (xi - xCg)
        y1 = (yi - yCg)
        mi = CLng(255 - F(xi, yi))
        MXX = MXX + y1 * y1 * mi
        MYY = MYY + x1 * x1 * mi
        MXY = MXY + x1 * y1 * mi
    Next yi
Next xi

If Not (MYY - MXX) = 0 Then
    prDir = 0.5 * Atn(2 * CDbl(MXY) / CDbl(MYY - MXX))
Else
    prDir = pi / 4
End If
If MXY < 0 And MYY - MXX <= 0 Then
    prDir = prDir - pi / 2
ElseIf MXY >= 0 And MYY - MXX < 0 Then
    prDir = prDir + pi / 2
End If


'Assigning direction to principal axis
mSlop = Tan(prDir)
mDist = 1 + mSlop * mSlop
Mpr1 = 0
Mpr2 = 0
For xi = 0 To xSize - 1
    For yi = 0 To ySize - 1
        x1 = (xi - xCg)
        y1 = (yi - yCg)
        mi = CLng(255 - F(xi, yi))
        DistMajor = y1 - mSlop * x1
        If x1 * Cos(prDir) + y1 * Sin(prDir) > 0 And x1 * Sin(prDir) - y1 * Cos(prDir) > 0 Then
            Mpr1 = Mpr1 + mi * DistMajor * DistMajor / mDist
        ElseIf x1 * Cos(prDir) + y1 * Sin(prDir) < 0 And x1 * Sin(prDir) - y1 * Cos(prDir) < 0 Then
            Mpr2 = Mpr2 + mi * DistMajor * DistMajor / mDist
        End If
    Next yi
Next xi

If Mpr2 < Mpr1 Then
    If prDir > 0 Then
        prDir = prDir - pi
    Else
        prDir = prDir + pi
    End If
End If
    
End Function




Public Function DirectiveGrad1(F() As Byte, xSize As Integer, ySize As Integer, xi As Integer, yi As Integer, dirGrads() As Single) As Integer
Dim dirNo As Integer, dirGap As Single
Dim a As Integer, b As Integer, i As Integer
Dim xx As Single, yy As Single, stp As Integer, wdth As Integer
Dim xxt As Single, yyt As Single
Dim pt As Single, wtsum As Single, wt As Single
Dim rFact As Single, rIndx As Integer, maxthk As Integer '**
Dim xp As Single, yp As Single, eps1 As Integer

' dirNo is the number of directional lines along which the search is done
dirNo = 8  ' Can't be changed
eps1 = 25

xp = CSng(xi)
yp = CSng(yi)
pt = CSng(255 - F(xi, yi))

i = -1
For a = -1 To 1
    For b = -1 To 1
        i = i + 1
        If a = 0 And b = 0 Then
            i = i - 1
            GoTo ths
        End If
        dirGrads(i) = 0
        wtsum = 0
        If a * b = 0 Then
            rFact = 1
            rIndx = 0 '**
        Else
            rFact = Root2
            rIndx = 1 '**
        End If
        For stp = 1 To eps1 '***
            'xx = xp + setSign(a, stp)
            'yy = yp + setSign(b, stp)
            xx = xp + a * stp / rFact '***
            yy = yp + b * stp / rFact '***
            maxthk = CInt(thk * stp)
            For wdth = -maxthk To maxthk
                xxt = xx + b * wdth / rFact '***
                yyt = yy - a * wdth / rFact '***
                'xxt = xx + setSign(a, wdth)
                'yyt = yy - setSign(b, wdth)
                If (xxt >= 0) And (yyt >= 0) And (xxt < xSize) And (yyt < ySize) Then
                    ' dirGrads(i) = dirGrads(i) + CSng(F(xx, yy)) * (CSng(F(xx, yy)) - pt) / r
                    ' wt = 1 / (r * CSng(Abs(wdth) + 1))
                    wt = 1 / Sqr(CSng(stp) + eps1 / 2) '***
                    dirGrads(i) = dirGrads(i) + CSng(255 - F(Round(xxt), Round(yyt))) * wt '***
                    wtsum = wtsum + wt
                End If
            Next wdth
        Next stp
        If Not (dirGrads(i) = 0) Then
            dirGrads(i) = dirGrads(i) / wtsum
        End If
ths:
    Next b
Next a

DirectiveGrad1 = 1
End Function



Public Function GetMeans3(F() As Byte, xSize As Integer, ySize As Integer, xCg As Integer, yCg As Integer, prDir As Single) As Integer
' Returns the CG and Principal direction (angle mage with +ve X-axis in radians) of the complement of F

Dim xi As Integer, yi As Integer, x1 As Integer, y1 As Integer
Dim m As Long, MX As Long, MXX As Long, MY As Long, MYY As Long, MXY As Long
Dim mi As Long, tmpGrads(7) As Single, a As Integer, gradSum As Single
Dim AngVal(7) As Integer

' Angle Values for GetMeans
AngVal(6) = 0
AngVal(7) = pi / 4
AngVal(4) = pi / 2
AngVal(2) = 3 * pi / 4
AngVal(1) = pi
AngVal(5) = -pi / 4
AngVal(3) = -pi / 2
AngVal(0) = -3 * pi / 4


m = MX = MXX = MY = MYY = MXY = 0

For xi = 0 To xSize - 1
    For yi = 0 To ySize - 1
        mi = CLng(255 - F(xi, yi))
        m = m + mi
        MX = MX + yi * mi
        MY = MY + xi * mi
    Next yi
Next xi

xCg = CInt(CSng(MY) / CSng(m))
yCg = CInt(CSng(MX) / CSng(m))

dum = DirectiveGrad1(F, xSize, ySize, xCg, yCg, tmpGrads)
prDir = 0
gradSum = 0
For a = 0 To 7
    prDir = prDir + AngVal(a) * tmpGrads(a)
    gradSum = gradSum + tmpGrads(a)
Next a
'prDir = prDir - pi * tmpGrads(1)
'gradSum = gradSum - pi
prDir = prDir / gradSum
Form1.Print prDir

End Function




Public Function GetMeans2(F() As Byte, xSize As Integer, ySize As Integer, xCg As Integer, yCg As Integer, prDir As Single) As Integer
' Returns the CG and Principal direction (angle mage with +ve X-axis in radians) of the complement of F

Dim xi As Integer, yi As Integer, x1 As Integer, y1 As Integer
Dim m As Long, MX As Long, MXX As Long, MY As Long, MYY As Long, MXY As Long
Dim mi As Single
Dim MR As Single, MRT As Single, ri As Single, thi As Single

m = MX = MXX = MY = MYY = MXY = 0

For xi = 0 To xSize - 1
    For yi = 0 To ySize - 1
        mi = CLng(255 - F(xi, yi))
        m = m + mi
        MX = MX + yi * mi
        MY = MY + xi * mi
    Next yi
Next xi

xCg = CInt(CSng(MY) / CSng(m))
yCg = CInt(CSng(MX) / CSng(m))
Form1.Print xCg, yCg

MR = MRT = 0
For xi = 0 To xSize - 1
    For yi = 0 To ySize - 1
        x1 = (xi - xCg)
        y1 = (yi - yCg)
        
        mi = CSng(255 - F(xi, yi))
        ri = Sqr(x1 * x1 + y1 * y1)
        
        If Not (x1 = 0) Then
            thi = Atn(y1 / x1)
        Else
            thi = pi / 2
        End If
        If y1 < 0 And x1 <= 0 Then
            thi = thi - pi / 2
        ElseIf y1 >= 0 And x1 < 0 Then
            thi = thi + pi / 2
        End If
        
        MR = MR + mi * r1
        MRT = MRT + mi * ri * thi
    Next yi
Next xi

prDir = MRT / MR

End Function


