Attribute VB_Name = "FileManager"

Public Function loadDataList() As Integer
Dim tmpNoOfChars As String, tmpChar As String, tmpNo As String
Dim filNo As Integer, count As Integer

filNo = FreeFile
Open App.Path & "\Database\DataList.dat" For Binary As #filNo
    tmpNoOfChars = "   "
    Get #filNo, , tmpNoOfChars
    charNo = Val(tmpNoOfChars)
    ' Form1.Print noOfChars
    
    ReDim chars(charNo), sampleNo(charNo)
    tmpChar = " "
    tmpNo = "  "
    maxSampleNo = 0
    For count = 1 To charNo
        Get #filNo, , tmpChar
        Get #filNo, , tmpNo
        chars(count) = tmpChar
        sampleNo(count) = Val(tmpNo)
        If sampleNo(count) > maxSampleNo Then
            maxSampleNo = sampleNo(count)
        End If
    Next count
Close #filNo
End Function


Public Function loadDataFile(fname As String, charIndex As Integer, sampleIndex As Integer) As Integer
Dim filNo As Integer, a As Integer, b As Integer

filNo = FreeFile
Open fname For Binary As #filNo
    Get #filNo, , vertNo(charIndex, sampleIndex)
    
    Get #filNo, , CGxR(charIndex, sampleIndex) ' Integer
    Get #filNo, , CGyR(charIndex, sampleIndex) ' Integer
    Get #filNo, , prDirR(charIndex, sampleIndex) ' Single
    Get #filNo, , CGxG(charIndex, sampleIndex) ' Integer
    Get #filNo, , CGyG(charIndex, sampleIndex) ' Integer
    Get #filNo, , prDirG(charIndex, sampleIndex) ' Single
    Get #filNo, , CGxB(charIndex, sampleIndex) ' Integer
    Get #filNo, , CGyB(charIndex, sampleIndex) ' Integer
    Get #filNo, , prDirB(charIndex, sampleIndex) ' Single

    
    ' Char_rec_startup.Print charIndex, sampleIndex, vertNo(charIndex, sampleIndex)
    For a = 0 To vertNo(charIndex, sampleIndex) - 1
        Get #filNo, , vertXs(charIndex, sampleIndex, a)
        Get #filNo, , vertYs(charIndex, sampleIndex, a)
        For b = 0 To 7
            Get #filNo, , dirGradR(charIndex, sampleIndex, a, b)
            Get #filNo, , dirGradG(charIndex, sampleIndex, a, b)
            Get #filNo, , dirGradB(charIndex, sampleIndex, a, b)
        Next b
    Next a
Close filNo
End Function


Public Function UpdateDataList(charName As String) As Integer
' Updates 'DataList.dat' for charName and returns the present file index for the charName
Dim filNo As Integer
Dim noOfChars As Integer, chars() As String, Nos() As Integer
Dim count As Integer
Dim tmpChar As String, tmpNo As String, tmpNoOfChars As String

' Reading 'DataList.dat'
filNo = FreeFile
Open App.Path & "\Database\DataList.dat" For Binary As #filNo
    tmpNoOfChars = "   "
    Get #filNo, , tmpNoOfChars
    noOfChars = Val(tmpNoOfChars)
    ' Form1.Print noOfChars
    
    ReDim chars(noOfChars + 1), Nos(noOfChars + 1)
    tmpChar = " "
    tmpNo = "  "
    For count = 1 To noOfChars
        Get #filNo, , tmpChar
        Get #filNo, , tmpNo
        chars(count) = tmpChar
        Nos(count) = Val(tmpNo)
    Next count
    chars(noOfChars + 1) = charName
    
    For count = 1 To noOfChars + 1
        If charName = chars(count) Then
            Exit For
        End If
    Next count
    
    If count = noOfChars + 1 Then
        noOfChars = noOfChars + 1
        chars(noOfChars) = charName
        Nos(noOfChars) = 1
        UpdateDataList = 1
    Else
        Nos(count) = Nos(count) + 1
        UpdateDataList = Nos(count)
    End If
Close #filNo

' Updating 'DataList.dat'
filNo = FreeFile
Open App.Path & "\Database\DataList.dat" For Binary As #filNo
    Put #filNo, , CnvStr(noOfChars, 3)
    For count = 1 To noOfChars
        Put #filNo, , chars(count)
        Put #filNo, , CnvStr(Nos(count), 2)
    Next count
Close #filNo
End Function


Public Function CnvStr(value As Integer, strLength As Integer) As String
' Converts value into a String of length strLen
Dim tmpStr As String, finalStr As String, tmpLen As Integer

tmpStr = Str(value)
tmpLen = Len(tmpStr) - 1
tmpStr = Right(tmpStr, tmpLen)
If tmpLen >= strLength Then
    ' Truncation
    finalStr = Right(tmpStr, strLength)
Else
    finalStr = String(strLength - tmpLen, "0") + tmpStr
End If

CnvStr = finalStr
End Function


Public Function saveDataFile(fname As String) As Integer
Dim filNo As Integer, a As Integer, b As Integer

filNo = FreeFile
Open fname For Binary As #filNo
    Put #filNo, , VertNoAdd ' Integer
    
    Put #filNo, , RedCGx ' Integer
    Put #filNo, , RedCGy ' Integer
    Put #filNo, , RedPrDir ' Single
    Put #filNo, , GreenCGx ' Integer
    Put #filNo, , GreenCGy ' Integer
    Put #filNo, , GreenPrDir ' Single
    Put #filNo, , BlueCGx ' Integer
    Put #filNo, , BlueCGy ' Integer
    Put #filNo, , BluePrDir ' Single

    For a = 0 To VertNoAdd - 1
        Put #filNo, , xsAdd(a) ' Integer
        Put #filNo, , ysAdd(a) ' Integer
        For b = 0 To 7
            Put #filNo, , redG(xsAdd(a), ysAdd(a), b) ' Single
            Put #filNo, , greenG(xsAdd(a), ysAdd(a), b) ' Single
            Put #filNo, , blueG(xsAdd(a), ysAdd(a), b) ' Single
        Next b
    Next a
Close filNo
End Function


