Attribute VB_Name = "Globals"
' Universal Globals
Public pi As Single, OneByRoot2 As Single, Root2 As Single

' =============================================


' Globals for Character Recognition

' Drawing tool Globals
Public xMouse As Single, yMouse As Single, IsMouseDown As Boolean, PtThickness As Single
Public rotIndexVal(8) As Single
Public rotIndices(8) As Integer, invRotIndices(8) As Integer
Public iVals(-6 To 6) As Integer

' Database Variables
Public chars() As String, sampleNo() As Integer, charNo As Integer
Public vertNo() As Integer
Public CGxR() As Integer, CGyR() As Integer, prDirR() As Single
Public CGxG() As Integer, CGyG() As Integer, prDirG() As Single
Public CGxB() As Integer, CGyB() As Integer, prDirB() As Single
Public vertXs() As Integer, vertYs() As Integer
Public dirGradR() As Single, dirGradG() As Single, dirGradB() As Single
Public maxSampleNo As Integer, maxVertNo As Integer
' charNo = no. of characters in database
' chars(charIndex = 1 to charNo) stores the characters
' sampleNo(charIndex = 1 to charNo) stores the no. of samples corrosponding to each Character
' vertNo(charIndex, sampleNo) stores the number of vertices
' CG..(charIndex, sampleNo) stores the Center of Gravity of the colour field
' prDir.(charIndex, sampleNo) stores the angle that the principal direction makes with the +ve X-axis
' vertXs(charIndex, sampleNo, vertNo) and vertYs(charIndex, sampleNo, vertNo) stores the coordinate of the vertices
' dirGradR(charIndex, sampleNo, vertNo, 0 to 7) stores directive grads for Red layer, etc.

' Globals for the unknown pattern
Public xmax As Integer, ymax As Integer, maxExtentFact As Single
Public redL() As Byte, greenL() As Byte, blueL() As Byte
Public RedCGx As Integer, RedCGy As Integer, RedPrDir As Single
Public GreenCGx As Integer, GreenCGy As Integer, GreenPrDir As Single
Public BlueCGx As Integer, BlueCGy As Integer, BluePrDir As Single
Public redG() As Single, greenG() As Single, blueG() As Single
Public dirWt() As Single, eps As Integer, thk As Single
Public shifts() As Integer

' Tollerence Levels
Public rTol As Single, thTol As Single, LocalErrTol As Single, accptPropFactor As Single, selptWtExponent As Single, maxAccptErr As Single, SearchSizeFact As Single, LocGlobBalnce As Single, RejectCrit As Single

' Variables for Database Addition
Public xsAdd(50) As Integer, ysAdd(50) As Integer
Public recognized As Boolean
Public VertNoAdd As Integer


Public Function MaxS(sng1 As Single, sng2 As Single) As Single
If sng1 > sng2 Then
    MaxS = sng1
Else
    MaxS = sng2
End If
End Function

Public Function MinS(sng1 As Single, sng2 As Single) As Single
If sng1 < sng2 Then
    MinS = sng1
Else
    MinS = sng2
End If
End Function

Public Function MaxI(sng1 As Integer, sng2 As Integer) As Integer
If sng1 > sng2 Then
    MaxI = sng1
Else
    MaxI = sng2
End If
End Function

Public Function MinI(sng1 As Integer, sng2 As Integer) As Integer
If sng1 < sng2 Then
    MinI = sng1
Else
    MinI = sng2
End If
End Function

