Attribute VB_Name = "Module1"
Public xi As Single, yi As Single, mouseDown As Boolean, thickness As Single, isLine As Boolean
Public redL() As Byte, greenL() As Byte, blueL() As Byte
Public xmax As Integer, ymax As Integer
Public xs(50) As Integer, ys(50) As Integer, vertNo As Integer
Public dirGradR() As Single, dirGradG() As Single, dirGradB() As Single
Public CGxR As Integer, CGyR As Integer, prDirR As Single
Public CGxG As Integer, CGyG As Integer, prDirG As Single
Public CGxB As Integer, CGyB As Integer, prDirB As Single
Public pi As Single, OneByRoot2 As Single, Root2 As Single
Public corner1X As Integer, corner1Y As Integer, corner2X As Integer, corner2Y As Integer


Public Function DrawLine(x1 As Single, y1 As Single, x2 As Single, y2 As Single) As Integer
Dim m As Single, thk As Single
Dim xt As Single, yt As Single

thk = (thickness - 1) / 2
If x1 = x2 Then
    m = 1000000 * Sgn(y2 - y1)
Else
    m = (y2 - y1) / (x2 - x1)
End If

If Abs(m) <= 1 Then
    For xt = x1 To x2 Step Sgn(x2 - x1)
        yt = y1 + (xt - x1) * m
        If thk = 0 Then
            Form1.Picture1.PSet (xt, yt)
        Else
            Form1.Picture1.Circle (xt, yt), thk
        End If
        'Form1.Picture1.Line (xt - thk, yt - thk)-(xt + thk, yt + thk), , BF
    Next xt
Else
    For yt = y1 To y2 Step Sgn(y2 - y1)
        xt = x1 + (yt - y1) / m
        If thk = 0 Then
            Form1.Picture1.PSet (xt, yt)
        Else
            Form1.Picture1.Circle (xt, yt), thk
        End If
        'Form1.Picture1.Line (xt - thk, yt - thk)-(xt + thk, yt + thk), , BF
    Next yt
End If

End Function


Public Function UpdateDataList(charName As String) As Integer
' Updates 'DataList.dat' for charName and returns the present file index for the charName
Dim filNo As Integer
Dim noOfChars As Integer, chars() As String, Nos() As Integer
Dim count As Integer
Dim tmpChar As String, tmpNo As String, tmpNoOfChars As String

' Reading 'DataList.dat'
filNo = FreeFile
Open "..\CGSM project - Image Processing and Pattern Recognition\Database\DataList.dat" For Binary As #filNo
    tmpNoOfChars = "   "
    Get #filNo, , tmpNoOfChars
    noOfChars = Val(tmpNoOfChars)
    ' Form1.Print noOfChars
    
    ReDim chars(noOfChars + 1), Nos(noOfChars + 1)
    tmpChar = " "
    tmpNo = "  "
    For count = 1 To noOfChars
        Get #filNo, , tmpChar
        Get #filNo, , tmpNo
        chars(count) = tmpChar
        Nos(count) = Val(tmpNo)
    Next count
    chars(noOfChars + 1) = charName
    
    For count = 1 To noOfChars + 1
        If charName = chars(count) Then
            Exit For
        End If
    Next count
    
    If count = noOfChars + 1 Then
        noOfChars = noOfChars + 1
        chars(noOfChars) = charName
        Nos(noOfChars) = 1
        UpdateDataList = 1
    Else
        Nos(count) = Nos(count) + 1
        UpdateDataList = Nos(count)
    End If
Close #filNo

' Updating 'DataList.dat'
filNo = FreeFile
Open "..\CGSM project - Image Processing and Pattern Recognition\Database\DataList.dat" For Binary As #filNo
    Put #filNo, , CnvStr(noOfChars, 3)
    For count = 1 To noOfChars
        Put #filNo, , chars(count)
        Put #filNo, , CnvStr(Nos(count), 2)
    Next count
Close #filNo
End Function


Public Function CnvStr(value As Integer, strLength As Integer) As String
' Converts value into a String of length strLen
Dim tmpStr As String, finalStr As String, tmpLen As Integer

tmpStr = Str(value)
tmpLen = Len(tmpStr) - 1
tmpStr = Right(tmpStr, tmpLen)
If tmpLen >= strLength Then
    ' Truncation
    finalStr = Right(tmpStr, strLength)
Else
    finalStr = String(strLength - tmpLen, "0") + tmpStr
End If

CnvStr = finalStr
End Function


Public Function saveDataFile(fname As String) As Integer
Dim filNo As Integer, a As Integer, b As Integer

filNo = FreeFile
Open fname For Binary As #filNo
    Put #filNo, , vertNo ' Integer
    
    Put #filNo, , CGxR ' Integer
    Put #filNo, , CGyR ' Integer
    Put #filNo, , prDirR ' Single
    Put #filNo, , CGxG ' Integer
    Put #filNo, , CGyG ' Integer
    Put #filNo, , prDirG ' Single
    Put #filNo, , CGxB ' Integer
    Put #filNo, , CGyB ' Integer
    Put #filNo, , prDirB ' Single
    
    For a = 0 To vertNo - 1
        Put #filNo, , xs(a) ' Integer
        Put #filNo, , ys(a) ' Integer
        For b = 0 To 7
            Put #filNo, , dirGradR(a, b) ' Single
            Put #filNo, , dirGradG(a, b) ' Single
            Put #filNo, , dirGradB(a, b) ' Single
        Next b
    Next a
Close filNo
End Function


Public Function SeparateLayers() As Integer
Dim a As Integer, b As Integer, pt As Long
ReDim redL(xmax, ymax), greenL(xmax, ymax), blueL(xmax, ymax)

' Separate the image layers
For a = 0 To xmax - 1
For b = 0 To ymax - 1
    pt = Form1.Picture1.Point(a, b)
    redL(a, b) = CByte(pt Mod 256)
    pt = Fix(pt / 256)
    greenL(a, b) = CByte(pt Mod 256)
    pt = Fix(pt / 256)
    blueL(a, b) = CByte(pt Mod 256)
Next b
Next a
End Function
