Attribute VB_Name = "cplx"
Public Type cplxpt
' A complex point in polar coordinates
    r As Single
    th As Single
End Type


Public Function getCplx(sx As Single, sy As Single) As cplxpt
'Dim sx As Single, sy As Single
'sx = CSng(x)
'sy = CSng(y)

getCplx.r = Sqr(sx * sx + sy * sy)
If Not (sx = 0) Then
    getCplx.th = Atn(sy / sx)
Else
    getCplx.th = pi / 2
End If

If sx <= 0 And sy < 0 Then
    getCplx.th = getCplx.th - pi
End If
If sx < 0 And sy >= 0 Then
    getCplx.th = getCplx.th + pi
End If
End Function


Public Function cplxDiv(z1 As cplxpt, z2 As cplxpt) As cplxpt
If Not (z2.r = 0) Then
    cplxDiv.r = z1.r / z2.r
Else
    cplxDiv.r = 10000#
End If
cplxDiv.th = z1.th - z2.th

If cplxDiv.th > pi Then
    cplxDiv.th = cplxDiv.th - 2 * pi
End If
If cplxDiv.th < -pi Then
    cplxDiv.th = cplxDiv.th + 2 * pi
End If
End Function
