Attribute VB_Name = "Img_process"
Public InX As Integer, InY As Integer, OutX As Integer, OutY As Integer
Public Xfact As Single, Yfact As Single
Public pr1(11) As Single, pr2(11) As Single
Public pfact1 As Single, pfact2 As Single
Public fnIndx As Integer

'Public prDiff1 As Single, prDiff2 As Single
'Public pfactDiff1 As Single, pfactDiff2 As Single
'Public prShrp1 As Single, prShrp2 As Single
'Public pfactShrp1 As Single, pfactShrp2 As Single
'Public prSol1 As Single, prSol2 As Single
'Public pfactSol1 As Single, pfactSol2 As Single
'Public prEmb1 As Single, prEmb2 As Single
'Public pfactEmb1 As Single, pfactEmb2 As Single
'Public prSmth1 As Single, prSmth2 As Single
'Public pfactSmth1 As Single, pfactSmth2 As Single
'Public prBin1 As Single, prBin2 As Single
'Public pfactBin1 As Single, pfactBin2 As Single
'Public prLin1 As Single, prLin2 As Single
'Public pfactLin1 As Single, pfactLin2 As Single


' **** fnIndx = 1
Public Function Smoothen(InLayer() As Byte, InX As Integer, InY As Integer, OutLayer() As Byte, OutX As Integer, OutY As Integer) As Integer

Dim i As Integer, j As Integer, tmp As Integer
Dim a As Integer, b As Integer

For i = pr1(1) To InX - (pr1(1) + 1)
    For j = pr1(1) To InY - (pr1(1) + 1)
        tmp = 0
        For a = -pr1(1) To pr1(1)
        For b = -pr1(1) To pr1(1)
            tmp = tmp + InLayer(i + a, j + b)
        Next b
        Next a
        OutLayer(i, j) = CByte(tmp / ((2 * pr1(1) + 1) ^ 2))
    Next j
Next i

OutX = InX
OutY = InY
End Function


' ***** fnIndx = 2
Public Function Negative(InLayer() As Byte, InX As Integer, InY As Integer, OutLayer() As Byte, OutX As Integer, OutY As Integer) As Integer

Dim a, b As Integer

For a = 0 To InX - 1
For b = 0 To InY - 1
    OutLayer(a, b) = 255 - InLayer(a, b)
Next b
Next a

OutX = InX
OutY = InY

End Function


' ******* fnIndx = 3
'Scale_factor determines the brightness level of the
 ' image...Larger SF means larger Brightness

Public Function Sharpen(InLayer() As Byte, InX As Integer, InY As Integer, OutLayer() As Byte, OutX As Integer, OutY As Integer) As Integer

Dim a, b, temp As Integer

'Const pr1(3) As Single = 0.5
Const Dx As Integer = 1
Const Dy As Integer = 1

For a = 0 + Dx To InX - 1 - Dx
For b = 0 + Dy To InY - 1 - Dy
    
    temp = CInt(InLayer(a, b)) + CInt(pr1(3) * (CInt((InLayer(a, b)) - CInt(InLayer(a - Dx, b - Dy)))))
    
    If (temp > 255) Then
        temp = 255
    End If
        
    If (temp < 0) Then
      temp = 0
    End If
    
    OutLayer(a, b) = CByte(temp)
    
Next b
Next a

OutX = InX
OutY = InY

End Function


' ********* fnIndx = 4
'Changeable Values Dx,Dy,Default_Color
Public Function Emboss(InLayer() As Byte, InX As Integer, InY As Integer, OutLayer() As Byte, OutX As Integer, OutY As Integer) As Integer

Dim a, b, temp As Integer

'Const Dx As Integer = -1
'Const Dy As Integer = 1
'Const Default_Color As Integer = 128

For a = 0 + Abs(pr1(4)) To InX - 1 - Abs(pr1(4))
For b = 0 + Abs(pr1(4)) To InY - 1 - Abs(pr1(4))
    
    temp = CInt(InLayer(a, b)) - CInt(InLayer(a - CInt(pr1(4)), b + CInt(pr1(4)))) + CInt(pr2(4))
    
    If (temp > 255) Then
        temp = 255
    End If
        
    If (temp < 0) Then
      temp = 0
    End If
    
    OutLayer(a, b) = CByte(temp)
    
Next b
Next a

OutX = InX
OutY = InY

End Function


Public Function Random() As Integer

Dim temp1, temp2 As Integer
temp1 = Rnd()
temp2 = temp1 Mod pr1(fnIndx)
If (temp1 Mod 2 = 0) Then
    Random = temp2
Else
    Random = -temp2
End If

End Function

    



' *********** fnIndx = 5
'Changeable Value is of the number by which Mod is taken
 'in Random function
Public Function Diffuse(InLayer() As Byte, InX As Integer, InY As Integer, OutLayer() As Byte, OutX As Integer, OutY As Integer) As Integer

Dim a, b, Rx, Ry As Integer




For a = 2 To InX - 3
For b = 2 To InY - 3
    
    Rx = Random()
    Ry = Random()
    
    OutLayer(a, b) = InLayer(a + Rx, b + Ry)
    
        
Next b
Next a

OutX = InX
OutY = InY

End Function



' ****** fnIndx = 6
'Changeable Value : Threshold Value
Public Function Solarise(InLayer() As Byte, InX As Integer, InY As Integer, OutLayer() As Byte, OutX As Integer, OutY As Integer) As Integer


Dim a As Integer, b As Integer
'Const Threshold As Integer = 128
For a = 0 To InX - 1
For b = 0 To InY - 1
            
            If (InLayer(a, b) <= pr1(6)) Then
                OutLayer(a, b) = 255 - InLayer(a, b)
                         
            Else
                OutLayer(a, b) = InLayer(a, b)
            End If
            
        Next b
        Next a

OutX = InX
OutY = InY
End Function


' ********* fnIndx = 7
Public Function Gray_Scale(InLayerR() As Byte, InLayerG() As Byte, InLayerB() As Byte, InX As Integer, InY As Integer, OutLayerR() As Byte, OutLayerG() As Byte, OutLayerB() As Byte, OutX As Integer, OutY As Integer) As Integer


Dim a As Integer, b As Integer, temp As Single
'Const th As Integer = 200


'type_GS = pr1(7)
For a = 0 To InX - 1
For b = 0 To InY - 1
    
    'If (pr1(7) = 1) Then '
        temp = CInt(Min(InLayerR(a, b), InLayerG(a, b), InLayerB(a, b)))
    'ElseIf (pr1(7) = 2) Then
        'temp = CInt(CInt(InLayerR(a, b)) + CInt(InLayerG(a, b)) + CInt(InLayerB(a, b)) / 3)
    'End If
    'If ((InLayerR(a, b) > Th) Or (InLayerG(a, b) > Th) Or (InLayerB(a, b) > Th)) Then
        
     '   OutLayerR(a, b) = 255
     '   OutLayerG(a, b) = 255
     '   OutLayerB(a, b) = 255
        
    'Else
        
     '   OutLayerR(a, b) = 0
     '   OutLayerG(a, b) = 0
     '    OutLayerB(a, b) = 0
    'End If
     If (temp > 255) Then
        temp = 255
     End If
        OutLayerR(a, b) = CByte(temp)
        OutLayerG(a, b) = CByte(temp)
        OutLayerB(a, b) = CByte(temp)
        
     ' Else
      '
       ' OutLayerR(a, b) = 0
        'OutLayerG(a, b) = 0
   '     OutLayerB(a, b) = 0
    
    'End If
        
    
        
Next b
Next a

OutX = InX
OutY = InY

End Function


' ********* fnIndx = 8
Public Function Hough(InLayerR() As Byte, InLayerG() As Byte, InLayerB() As Byte, InX As Integer, InY As Integer, OutLayerR() As Byte, OutLayerG() As Byte, OutLayerB() As Byte, OutX As Integer, OutY As Integer) As Integer

Dim X As Integer, Y As Integer, xmax As Integer
Dim a As Integer, b As Integer, rMax As Integer, thetamax As Integer
'Const Threshold As Integer = 128
Dim r As Integer, theta As Integer, flag As Boolean, count As Integer

Dim H() As Integer, dummy As Integer

rMax = CInt(Sqr((InX - 1) ^ 2 + (InY - 1) ^ 2) / 2)
thetamax = 180
ReDim H(thetamax, 2 * rMax)
ReDim OutLayerR(thetamax, 2 * rMax), OutLayerG(thetamax, 2 * rMax), OutLayerB(thetamax, 2 * rMax)


'INITIALISING HOUGH MATRIX
For theta = 0 To thetamax - 1
For r = 0 To rMax - 1
    H(theta, r) = 0
Next r
Next theta


'CALCULATING THE HOUGH MATRIX
For a = -(InX - 1) / 2 To (InX - 1) / 2
For b = -(InY - 1) / 2 To (InY - 1) / 2
            
            If (InLayerR(a + (InX - 1) / 2, b + (InY - 1) / 2) = 255) Then
                For theta = 0 To thetamax - 1
                         r = CInt(a * Cos(theta * 3.14 / 180) + b * Sin(theta * 3.14 / 180)) + rMax
                         
                         If (r < 2 * (rMax - 1) And (r > 0)) Then
                            H(theta, r) = H(theta, r) + pr1(8)
                         End If
                Next theta
            End If
            
Next b
Next a

OutX = 180
OutY = 2 * rMax

'PLOTTING THE HOUGH ARRAY
For a = 0 To OutX - 1
For b = 0 To OutY - 1
    If (H(a, b) > 255) Then
        H(a, b) = 255
    End If
   OutLayerR(a, b) = H(a, b)
   OutLayerG(a, b) = H(a, b)
   OutLayerB(a, b) = H(a, b)


Next b
Next a


End Function


' ********** fnIndx = 9
Public Function Sobel_Gradient(InLayer() As Byte, InX As Integer, InY As Integer, OutLayer() As Byte, OutX As Integer, OutY As Integer) As Integer

Dim a, b, i, temp As Integer
Dim P As Integer, Q As Integer, r As Integer, S As Integer

For a = 2 To InX - 3
For b = 2 To InY - 3
    P = 0
    Q = 0
    r = 0
    S = 0
   For i = -1 To 1
    P = P + InLayer(a + 1, b + i) * (2 - Abs(i))
    Q = Q + InLayer(a - 1, b + i) * (2 - Abs(i))
    r = r + InLayer(a + i, b + 1) * (2 - Abs(i))
    S = S + InLayer(a + i, b - 1) * (2 - Abs(i))
   Next i
    
  temp = CInt(Sqr((P - Q) ^ 2 + (r - S) ^ 2) * pr1(9))
    
    If (temp > 255) Then
        temp = 255
    End If
    
  OutLayer(a, b) = CByte(temp)
    
Next b
Next a

OutX = InX
OutY = InY

End Function


' ******** fnIndx = 10
Public Function Black_White(InLayerR() As Byte, InLayerG() As Byte, InLayerB() As Byte, InX As Integer, InY As Integer, OutLayerR() As Byte, OutLayerG() As Byte, OutLayerB() As Byte, OutX As Integer, OutY As Integer) As Integer


Dim a As Integer, b As Integer, temp As Integer
'Const th As Integer = 128



For a = 0 To InX - 1
For b = 0 To InY - 1
    
    'temp = CInt(CInt(InLayerR(a, b)) + CInt(InLayerG(a, b)) + CInt(InLayerB(a, b)) / 3)
    temp = CInt(Max(InLayerR(a, b), InLayerG(a, b), InLayerB(a, b)))
      
       
      If (temp > CInt(pr1(10))) Then
        OutLayerR(a, b) = 255
        OutLayerG(a, b) = 255
        OutLayerB(a, b) = 255
      Else
     
        OutLayerR(a, b) = 0
        OutLayerG(a, b) = 0
        OutLayerB(a, b) = 0
    
      End If
        
    
        
Next b
Next a

OutX = InX
OutY = InY

End Function



Public Function Black_White_hough(InLayerR() As Byte, InLayerG() As Byte, InLayerB() As Byte, InX As Integer, InY As Integer, OutLayerR() As Byte, OutLayerG() As Byte, OutLayerB() As Byte, OutX As Integer, OutY As Integer) As Integer


Dim a As Integer, b As Integer, temp As Integer
'Const th As Integer = 128



For a = 0 To InX - 1
For b = 0 To InY - 1
    
    temp = CInt(CInt(InLayerR(a, b)) + CInt(InLayerG(a, b)) + CInt(InLayerB(a, b)) / 3)
    'temp = CInt(Max(InLayerR(a, b), InLayerG(a, b), InLayerB(a, b)))
      
       
      If (temp > CInt(pr1(10))) Then
        OutLayerR(a, b) = 255
        OutLayerG(a, b) = 255
        OutLayerB(a, b) = 255
      Else
     
        OutLayerR(a, b) = 0
        OutLayerG(a, b) = 0
        OutLayerB(a, b) = 0
    
      End If
        
    
        
Next b
Next a

OutX = InX
OutY = InY

End Function



' ******** fnIndx = 11
Public Function Hough_Line(InLayerR() As Byte, InLayerG() As Byte, InLayerB() As Byte, InX As Integer, InY As Integer, OutLayerR() As Byte, OutLayerG() As Byte, OutLayerB() As Byte, OutX As Long, OutY As Long) As Integer

'Dim temp_array() As Integer, address_array() As Long
'Dim X As Long, Y As Long
Dim xmax As Long, dummy As Long, size As Long
Dim a As Long, b As Long, rMax As Long, thetamax As Long, temp As Long
Dim xtemp1 As Long, xtemp2 As Long, ytemp1 As Long, ytemp2 As Long
Dim r As Long, theta As Long, flag As Boolean, count1 As Long, count2 As Long
'Const th As Integer = 300
Dim H() As Long, HMax As Long
Dim i As Long


Dim max_matrix(40) As Long, address(40) As Long

rMax = CLng(Sqr((InX - 1) ^ 2 + (InY - 1) ^ 2) / 2)
thetamax = 360
ReDim H(thetamax, 2 * rMax)
'ReDim OutLayerR(InX, InY), OutLayerG(InX, InY), OutLayerB(InX, InY)
size = (thetamax) * (thetamax)

ReDim temp_array(size)
ReDim address_array(size)


'INITIALISING HOUGH MATRIX
For theta = 0 To thetamax - 1
For r = 0 To 2 * rMax - 1
    H(theta, r) = 0
Next r
Next theta


'CALCULATING THE HOUGH MATRIX
For a = -(InX - 1) / 2 To (InX - 1) / 2
For b = -(InY - 1) / 2 To (InY - 1) / 2
            
            If (InLayerR(a + (InX - 1) / 2, b + (InY - 1) / 2) = 255) Then
                For theta = 0 To thetamax - 1
                         'temp = CInt(a * Cos(theta * 3.14 / 180) + b * Sin(theta * 3.14 / 180)) + rMax
                         r = CInt(a * Cos(theta * 3.14 / 180) + b * Sin(theta * 3.14 / 180)) + rMax
                         
                         If (r < (2 * rMax - 1) And (r > 0)) Then
                            H(theta, r) = H(theta, r) + pr1(8)
                         End If
                Next theta
            End If

Next b
Next a

OutX = InX
OutY = InY

Image_Process.OutImg.Width = CInt(CSng(OutX) * 1.051948052)
Image_Process.OutImg.Height = CInt(CSng(OutY) * 1.057971014)
'**********************copying******************************
'For X = 0 To InX - 1
'For Y = 0 To InY - 1
        'Call Image_Process.Command14.Command14_Click
        'Image_Process.OutImg.PSet (X, Y), RGB(InLayerR(X, Y), InLayerG(X, Y), InLayerB(X, Y))
'Next Y
'Next X

'OutX = Image_Process.InImg.ScaleWidth
'OutY = Image_Process.InImg.ScaleHeight
Image_Process.OutImg.Width = Image_Process.InImg.Width
Image_Process.OutImg.Height = Image_Process.InImg.Height
Image_Process.OutImg.ScaleWidth = OutX
Image_Process.OutImg.ScaleHeight = OutY

For a = 0 To OutX - 1
For b = 0 To OutY - 1
    Image_Process.OutImg.PSet (a, b), Image_Process.InImg.Point(a, b)
    'Image_Process.OutImg.PSet (a, b), H(a, b)
Next b
Next a


'*******************drawing the lines************************



'***/*/**//*/*/*/**//*/**/*/*/*1ST METHOD* *
'**/*/***/**/**/*/**/*/*******/*/**/*/*/*/*/*/
'////////////////////SORTING/////////////////////
'dummy = sort(H, thetaMax, rMax, temp_array, address_array)
'For i = 0 To 9
  'R = CInt(address_array(i) / rMax)
  'theta = address_array(i) Mod rMax
'
     'If (Not (theta = 90) And Not (theta = 270)) Then
                'ytemp1 = InY / 2
                'ytemp2 = -InY / 2
                'xtemp1 = (R - rMax - ytemp1 * Sin(theta * 3.14 / 180))/ Cos(theta * 3.14 / 180)
                'xtemp2 = (R - rMax - ytemp2 * Sin(theta * 3.14 / 180))/ Cos(theta * 3.14 / 180)
     'Else
                'ytemp1 = R - rMax
               'ytemp2 = R - rMax
              'xtemp1 = -(InX - 1) / 2
                'xtemp2 = (InX - 1) / 2
     'End If
'
         'Form1.OutImg.Line (xtemp1 + InX / 2, ytemp1 + InY /2)-(xtemp2 + InX / 2, ytemp2 + InY / 2), RGB(255, 0, 0)
'
'Next i
'CHECKING WHETHER H(theta,r)HAS THE MAXIMUM VALUE




HMax = -1000

For theta = pr1(11) To thetamax - (pr1(11) + 1)
For r = pr1(11) To 2 * rMax - (pr1(11) + 1)
    If (H(theta, r) > HMax) Then
        HMax = H(theta, r)
    End If
Next r
Next theta


'*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/ 2 ND METHOD
'*/*/*/*/*/*/*/*/*/*/*/*/*/*/*//*/*/*/
'////////////////////LOCAL MAXIMA////////////////////
Dim thetaDraw As Long, RDraw As Long, LocalHmax As Long

For theta = pr1(11) To thetamax - (pr1(11) + 1) Step pr1(11) / 2
For r = pr1(11) To 2 * rMax - (pr1(11) + 1) Step pr1(11) / 2
    '
    flag = False
    LocalHmax = 0
    For count1 = -pr1(11) To pr1(11)
    For count2 = -pr1(11) To pr1(11)
    
      If LocalHmax < H(theta + count1, r + count2) And H(theta + count1, r + count2) > CLng(pr2(11) * CSng(HMax)) Then
      '''If (H(theta, R) >= th) Then '
        thetaDraw = theta + count1
        RDraw = r + count2
        LocalHmax = H(theta + count1, r + count2)
        flag = True
      End If
'
   Next count2
   Next count1
         '
        If flag = True Then
            '
            If (Not (thetaDraw = 90) And Not (thetaDraw = 270)) Then
                ytemp1 = InY / 2
                ytemp2 = -InY / 2
                xtemp1 = (RDraw - rMax - ytemp1 * Sin(thetaDraw * 3.14 / 180)) / Cos(thetaDraw * 3.14 / 180)
                xtemp2 = (RDraw - rMax - ytemp2 * Sin(thetaDraw * 3.14 / 180)) / Cos(thetaDraw * 3.14 / 180)
            Else
                ytemp1 = RDraw - rMax
                ytemp2 = RDraw - rMax
                xtemp1 = -(InX - 1) / 2
                xtemp2 = (InX - 1) / 2
           End If

        Image_Process.OutImg.Line (xtemp1 + InX / 2, ytemp1 + InY / 2)-(xtemp2 + InX / 2, ytemp2 + InY / 2), RGB(255, 0, 0)

        End If
'
    '
'
      ''
'
    '
'
Next r
Next theta









'*/*/*/*/*/*/*/*/***/*/***/*/**/*/*/3RD METHOD
'*/*/*/*/*/*/*/*/*/*/*/*//*/*/*/*//**

'////////////////////////BY FINDING MAXIMAS//////////////////////////
'dummy = find_Maxima(H, rmax, thetamax, max_matrix, address)
'For i = 0 To 39
'  theta = CLng(address(i) / thetamax)
'  R = address(i) Mod thetamax
'
'     If (Not (theta = 90) And Not (theta = 270)) Then
'                ytemp1 = InY / 2
'                ytemp2 = -InY / 2
'                xtemp1 = (R - rmax - ytemp1 * Sin(theta * 3.14 / 180)) / Cos(theta * 3.14 / 180)
'                xtemp2 = (R - rmax - ytemp2 * Sin(theta * 3.14 / 180)) / Cos(theta * 3.14 / 180)
'     Else
'                ytemp1 = R - rmax
'                ytemp2 = R - rmax
'                xtemp1 = -(InX - 1) / 2
'                xtemp2 = (InX - 1) / 2
'     End If
''
'         Form1.OutImg.Line (xtemp1 + InX / 2, ytemp1 + InY / 2)-(xtemp2 + InX / 2, ytemp2 + InY / 2), RGB(255, 0, 0)
''
'Next i''

End Function



Public Function Hough_Line2(InLayerR() As Byte, InLayerG() As Byte, InLayerB() As Byte, InX As Integer, InY As Integer, OutLayerR() As Byte, OutLayerG() As Byte, OutLayerB() As Byte, OutX As Long, OutY As Long) As Integer

'Dim temp_array() As Integer, address_array() As Long
'Dim X As Long, Y As Long
Dim xmax As Long, dummy As Long, size As Long
Dim a As Long, b As Long, rMax As Long, thetamax As Long, temp As Long
Dim xtemp1 As Long, xtemp2 As Long, ytemp1 As Long, ytemp2 As Long
Dim r As Long, theta As Long, flag As Boolean, count1 As Long, count2 As Long
'Const th As Integer = 300
Dim H() As Long, HMax As Long
Dim i As Long


Dim max_matrix(40) As Long, address(40) As Long

rMax = CLng(Sqr((InX - 1) ^ 2 + (InY - 1) ^ 2) / 2)
thetamax = 360
ReDim H(thetamax, 2 * rMax)
'ReDim OutLayerR(InX, InY), OutLayerG(InX, InY), OutLayerB(InX, InY)
size = (thetamax) * (thetamax)

ReDim temp_array(size)
ReDim address_array(size)


'INITIALISING HOUGH MATRIX
For theta = 0 To thetamax - 1
For r = 0 To 2 * rMax - 1
    H(theta, r) = 0
Next r
Next theta


'CALCULATING THE HOUGH MATRIX
For a = -(InX - 1) / 2 To (InX - 1) / 2
For b = -(InY - 1) / 2 To (InY - 1) / 2
            
            If (InLayerR(a + (InX - 1) / 2, b + (InY - 1) / 2) = 255) Then
                For theta = 0 To thetamax - 1
                         'temp = CInt(a * Cos(theta * 3.14 / 180) + b * Sin(theta * 3.14 / 180)) + rMax
                         r = CInt(a * Cos(theta * 3.14 / 180) + b * Sin(theta * 3.14 / 180)) + rMax
                         
                         If (r < (2 * rMax - 1) And (r > 0)) Then
                            H(theta, r) = H(theta, r) + pr1(8)
                         End If
                Next theta
            End If

Next b
Next a

OutX = InX
OutY = InY

Image_Process.OutImg.Width = CInt(CSng(OutX) * 1.051948052)
Image_Process.OutImg.Height = CInt(CSng(OutY) * 1.057971014)
'**********************copying******************************
'For X = 0 To InX - 1
'For Y = 0 To InY - 1
        'Call Image_Process.Command14.Command14_Click
        'Image_Process.OutImg.PSet (X, Y), RGB(InLayerR(X, Y), InLayerG(X, Y), InLayerB(X, Y))
'Next Y
'Next X

'OutX = Image_Process.InImg.ScaleWidth
'OutY = Image_Process.InImg.ScaleHeight
Image_Process.OutImg.Width = Image_Process.InImg.Width
Image_Process.OutImg.Height = Image_Process.InImg.Height
Image_Process.OutImg.ScaleWidth = OutX
Image_Process.OutImg.ScaleHeight = OutY

For a = 0 To OutX - 1
For b = 0 To OutY - 1
    Image_Process.OutImg.PSet (a, b), Image_Process.InImg.Point(a, b)
    'Image_Process.OutImg.PSet (a, b), H(a, b)
Next b
Next a


'*******************drawing the lines************************



'***/*/**//*/*/*/**//*/**/*/*/*1ST METHOD* *
'**/*/***/**/**/*/**/*/*******/*/**/*/*/*/*/*/
'////////////////////SORTING/////////////////////
'dummy = sort(H, thetaMax, rMax, temp_array, address_array)
'For i = 0 To 9
  'R = CInt(address_array(i) / rMax)
  'theta = address_array(i) Mod rMax
'
     'If (Not (theta = 90) And Not (theta = 270)) Then
                'ytemp1 = InY / 2
                'ytemp2 = -InY / 2
                'xtemp1 = (R - rMax - ytemp1 * Sin(theta * 3.14 / 180))/ Cos(theta * 3.14 / 180)
                'xtemp2 = (R - rMax - ytemp2 * Sin(theta * 3.14 / 180))/ Cos(theta * 3.14 / 180)
     'Else
                'ytemp1 = R - rMax
               'ytemp2 = R - rMax
              'xtemp1 = -(InX - 1) / 2
                'xtemp2 = (InX - 1) / 2
     'End If
'
         'Form1.OutImg.Line (xtemp1 + InX / 2, ytemp1 + InY /2)-(xtemp2 + InX / 2, ytemp2 + InY / 2), RGB(255, 0, 0)
'
'Next i
'CHECKING WHETHER H(theta,r)HAS THE MAXIMUM VALUE




HMax = -1000

For theta = pr1(11) To thetamax - (pr1(11) + 1)
For r = pr1(11) To 2 * rMax - (pr1(11) + 1)
    If (H(theta, r) > HMax) Then
        HMax = H(theta, r)
    End If
Next r
Next theta


'*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/ 2 ND METHOD
'*/*/*/*/*/*/*/*/*/*/*/*/*/*/*//*/*/*/
'////////////////////LOCAL MAXIMA////////////////////
'Dim thetaDraw As Long, RDraw As Long, LocalHmax As Long

For theta = pr1(11) To thetamax - (pr1(11) + 1)
For r = pr1(11) To 2 * rMax - (pr1(11) + 1)
    '
    flag = True
    'LocalHmax = 0
    For count1 = -pr1(11) To pr1(11)
    For count2 = -pr1(11) To pr1(11)
    
      If H(theta, r) < H(theta + count1, r + count2) Then
      '''If (H(theta, R) >= th) Then '
        'thetaDraw = theta + count1
        'RDraw = r + count2
        'LocalHmax = H(theta + count1, r + count2)
        flag = False
      End If
'
   Next count2
   Next count1
         '
        If flag = True And H(theta, r) > CLng(pr2(11) * CSng(HMax)) Then
            '
            If (Not (theta = 90) And Not (theta = 270)) Then
                ytemp1 = InY / 2
                ytemp2 = -InY / 2
                xtemp1 = (r - rMax - ytemp1 * Sin(theta * 3.14 / 180)) / Cos(theta * 3.14 / 180)
                xtemp2 = (r - rMax - ytemp2 * Sin(theta * 3.14 / 180)) / Cos(theta * 3.14 / 180)
            Else
                ytemp1 = r - rMax
                ytemp2 = r - rMax
                xtemp1 = -(InX - 1) / 2
                xtemp2 = (InX - 1) / 2
           End If

        Image_Process.OutImg.Line (xtemp1 + InX / 2, ytemp1 + InY / 2)-(xtemp2 + InX / 2, ytemp2 + InY / 2), RGB(255, 0, 0)

        End If
'
    '
'
      ''
'
    '
'
Next r
Next theta

'*/*/*/*/*/*/*/*/***/*/***/*/**/*/*/3RD METHOD
'*/*/*/*/*/*/*/*/*/*/*/*//*/*/*/*//**

'////////////////////////BY FINDING MAXIMAS//////////////////////////
'dummy = find_Maxima(H, rmax, thetamax, max_matrix, address)
'For i = 0 To 39
'  theta = CLng(address(i) / thetamax)
'  R = address(i) Mod thetamax
'
'     If (Not (theta = 90) And Not (theta = 270)) Then
'                ytemp1 = InY / 2
'                ytemp2 = -InY / 2
'                xtemp1 = (R - rmax - ytemp1 * Sin(theta * 3.14 / 180)) / Cos(theta * 3.14 / 180)
'                xtemp2 = (R - rmax - ytemp2 * Sin(theta * 3.14 / 180)) / Cos(theta * 3.14 / 180)
'     Else
'                ytemp1 = R - rmax
'                ytemp2 = R - rmax
'                xtemp1 = -(InX - 1) / 2
'                xtemp2 = (InX - 1) / 2
'     End If
''
'         Form1.OutImg.Line (xtemp1 + InX / 2, ytemp1 + InY / 2)-(xtemp2 + InX / 2, ytemp2 + InY / 2), RGB(255, 0, 0)
''
'Next i''

End Function



Public Function find_Maxima(H() As Long, rMax As Long, thetamax As Long, max_matrix() As Long, address() As Long) As Long



Dim Max As Long, i As Long, r As Long, theta As Long

For i = 1 To 39
    address(i) = -1
Next i

'CALCULATING THE FIRST MAXIMUM
max_matrix(0) = 0
address(0) = -1
For theta = 0 To thetamax - 1
    For r = 0 To 2 * rMax - 1
        If (H(theta, r) > max_matrix(0)) Then
  
                max_matrix(0) = H(theta, r)
                address(0) = theta * thetamax + r
    
        End If
        
    Next r
Next theta

'CALCULATING NEXT MAXIMAS
For i = 1 To 39
    
 Max = 0

 For theta = 0 To thetamax - 1
    For r = 0 To 2 * rMax - 1
        If (Not ((thetamax * theta + r) = address(0)) And Not ((thetamax * theta + r) = address(1))) And Not ((thetamax * theta + r) = address(2)) And Not ((thetamax * theta + r) = address(3)) And Not ((thetamax * theta + r) = address(4)) And Not ((thetamax * theta + r) = address(5)) And Not ((thetamax * theta + r) = address(6)) And Not ((thetamax * theta + r) = address(7)) And Not ((thetamax * theta + r) = address(8)) And Not ((thetamax * theta + r) = address(9) And Not ((thetamax * theta + r) = address(10)) And Not ((thetamax * theta + r) = address(11))) And Not ((thetamax * theta + r) = address(12)) And Not ((thetamax * theta + r) = address(13)) And Not ((thetamax * theta + r) = address(14)) And Not ((thetamax * theta + r) = address(15)) And Not ((thetamax * theta + r) = address(16)) And Not ((thetamax * theta + r) = address(17)) And Not ((thetamax * theta + r) = address(18)) And Not ((thetamax * theta + r) = address(19)) Then
           If (Not ((thetamax * theta + r) = address(20)) And Not ((thetamax * theta + r) = address(21))) And Not ((thetamax * theta + r) = address(22)) And Not ((thetamax * theta + r) = address(23)) And Not ((thetamax * theta + r) = address(24)) And Not ((thetamax * theta + r) = address(25)) And Not ((thetamax * theta + r) = address(26)) And Not ((thetamax * theta + r) = address(27)) And Not ((thetamax * theta + r) = address(28)) And Not ((thetamax * theta + r) = address(29) And Not ((thetamax * theta + r) = address(30)) And Not ((thetamax * theta + r) = address(31))) And Not ((thetamax * theta + r) = address(32)) And Not ((thetamax * theta + r) = address(33)) And Not ((thetamax * theta + r) = address(34)) And Not ((thetamax * theta + r) = address(35)) And Not ((thetamax * theta + r) = address(36)) And Not ((thetamax * theta + r) = address(37)) And Not ((thetamax * theta + r) = address(38)) And Not ((thetamax * theta + r) = address(39)) Then
            If (H(theta, r) > Max) Then
  
                Max = H(theta, r)
                address(i) = theta * thetamax + r
    
            End If
        End If
        End If
    Next r
  Next theta

Next i
    
End Function


Public Function sort(H() As Integer, InX As Integer, InY As Integer, temp_array() As Integer, address_array() As Long) As Integer

    Dim n As Long, i As Long, j As Long, k As Long, exchange1 As Integer, exchange2 As Long
    n = CLng(InX) * CLng(InX)
    'Dim temp() As Integer
    'ReDim temp(n)
    
    For i = 0 To n - 1
    
        address_array(i) = i
    
    Next i
    
    For i = 0 To InX - 1
    For j = 0 To InY - 1

        temp_array(i * InX + j) = H(i, j)

    Next j
    Next i
    
    For k = 0 To n - 2
        
        For t = k + 1 To n - 1
        
            If (temp_array(k) < temp_array(t)) Then
                
                exchange1 = temp_array(t)
                temp_array(t) = temp_array(k)
                temp_array(k) = exchange1
            
                exchange2 = address_array(t)
                address_array(t) = address_array(k)
                address_array(k) = exchange2
            
            End If
         
         Next t
    
    Next k
End Function


Public Function Max(v1 As Byte, v2 As Byte, v3 As Byte) As Byte
Dim v As Byte
If v1 > v2 Then
    v = v1
Else
    v = v2
End If
If v3 > v Then
    Max = v3
Else
    Max = v
End If
End Function


Public Function Min(v1 As Byte, v2 As Byte, v3 As Byte) As Byte
Dim v As Byte
If v1 > v2 Then
    v = v2
Else
    v = v1
End If
If v3 > v Then
    Min = v
Else
    Min = v3
End If
End Function

